# Execute (PF): python generate_qc_format.py -p 7778 -m b827ebb7c0c7 -t PF -c log/calibration/csv/ -i 1 -r log/calibration/profile/
# VAC Format: <timestamp>,<sensor_mac>,<pacakge>,<package_index>,<data_type>,<data_type_index>,<data_value_list>
# Execute (VAC): python generate_qc_format.py -p 7778 -m 001ec03f6876 -t VAC -c log/calibration/csv/ -i 1 -r log/calibration/profile/
import sys,os
import getopt
#from pynovatec.events import EventPost, EventRegisterListener,EventUnregisterListener,EventQueueShutdown,EventListener
from pynovatec.events import EventQueueShutdown
from VacSensorCollector import VacSensorCollector

from ZmqCollection import ZmqCollection

#Temporay until more things are moved around.
from VacSensorCollector import set_csv_path, set_profile_path 


mac="b827eb4a4309"
package_type="PF"
package_index=1
start_time=0
port = "7778"
csvpath="log/calibration/csv/"
profilepath="log/calibration/profile/"


def getDataCollector(package_type,mac,package_index):
    if package_type.upper() == "VAC":
        return VacSensorCollector(package_type,mac,package_index)
    print("No sensor collector made..")

try:
    opts, args = getopt.getopt(sys.argv[1:],"m:p:t:c:i:r:")
except getopt.GetoptError:
    print("Error: Error in set options: ")
for opt,arg in opts:
    if opt == "-m":
        mac = arg
    elif opt == "-p":
        port = arg
    elif opt == "-t":
        package_type = arg
    elif opt == "-c":
        csvpath = arg
    elif opt == "-i":
        package_index = int(arg)
    elif opt == "-r":
        profilepath=arg

if not os.path.exists(csvpath) or not os.path.exists(profilepath):
    os.makedirs(csvpath,exist_ok=True)
    os.makedirs(profilepath,exist_ok=True)

# Just here for now.
set_csv_path(csvpath)
set_profile_path(profilepath)

sensor_id=f"{mac}_{package_type}_{package_index}"
content="14.7" if package_type == "VAC" else "251,10,251,10,251,10"

collector=getDataCollector(package_type,mac,package_index)

z=ZmqCollection(collector,port=port)
z.start()
#z.zmq_stream_data()
z.join()
#EventQueueShutdown()

