import sys
import time
import threading
import fnmatch
from queue import Queue

from pynovatec.events import EventListener, Events
from pynovatec.events import EventPost, EventRegisterListener,EventUnregisterListener,EventQueueShutdown


class QCEvents(Events):
    event_name='test'
    def __init__(self,data,*args,**kwargs):                    
        new_data = {
            'event_name':self.event_name,
            'data': data 
        }
        super().__init__(new_data,*args,**kwargs) 

class QCStateChange(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='state_change' 
        super().__init__(*args,**kwargs) 

class SensorDataPoint(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='point' 
        super().__init__(*args,**kwargs) 

class SensorDataBatchCollectionStarted(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='batch_collection_started' 
        super().__init__(*args,**kwargs) 

class SensorDataBatchCollectionComplete(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='batch_collection_complete' 
        super().__init__(*args,**kwargs) 

class SensorDataCollectionComplete(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='collection_complete' 
        super().__init__(*args,**kwargs) 

class SensorDataCalibrationComplete(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='calibration_complete' 
        super().__init__(*args,**kwargs) 

class SensorDataCollectionError(QCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='collection_error' 
        super().__init__(*args,**kwargs) 

                                                          
class QCListener(EventListener):                            
    def __init__(self,*args,**kwargs):                                   
        super().__init__(*args,**kwargs)                                
        self.events.append(QCEvents)                    
                                                          
    def handle(self,msg):                                 
        print("QC Listener run: ",msg.data)                  
                                                          
                                                          
